module Emarsys
  module Api
    ESCHER_AUTH_OPTIONS = {
      algo_prefix: 'EMS',
      vendor_key: 'EMS',
      auth_header_name: 'X-Ems-Auth',
      date_header_name: 'X-Ems-Date'
    }.freeze


    autoload :Base, 'emarsys/api/base'
    autoload :Error, 'emarsys/api/error'
    autoload :RecoverableError, 'emarsys/api/error'
    autoload :IrrecoverableError, 'emarsys/api/error'
    autoload :BadRequestError, 'emarsys/api/error'
    autoload :UnauthorizedError, 'emarsys/api/error'
    autoload :Services, 'emarsys/api/services'
    autoload :Internal, 'emarsys/api/internal'


    def self.base_url
      ENV['EMARSYS_API_URL'] || 'https://api.emarsys.net'
    end
  end
end
