module Emarsys
  module Api
    class Error < ::StandardError
      attr_reader :error_code, :reply_code

      def initialize(message, error_code, reply_code)
        super(message)
        @error_code = error_code
        @reply_code = reply_code
      end

      def as_json(*_args)
        { message: message, error_code: error_code, reply_code: reply_code }
      end
    end

    class RecoverableError < Error
    end

    class IrrecoverableError < Error
    end

    class BadRequestError < Error
    end

    class UnauthorizedError < Error
    end
  end
end
