module Emarsys
  module Api
    class Internal < Base
      attr_reader :customer_id


      def initialize(customer_id)
        @customer_id = customer_id
      end

      def campaign_get(campaign_id)
        client.get("email/#{campaign_id}").tap { |response| validate_response! response }.body['data']
      end

      def fields_get
        client.get('field/translate/en').tap { |response| validate_response!(response) }.body['data']
      end

      def field_create(type, name)
        params = { name: name, application_type: type }
        headers = { 'Content-Type' => 'application/json' }
        client.post('field', params.to_json, headers).tap { |response| validate_response!(response) }.body['data']
      end

      def field_delete(field_id)
        headers = { 'Content-Type' => 'application/json' }
        url = "field/#{field_id}/delete"
        client.delete(url, nil, headers).tap { |response| validate_response!(response) }.body['data']
      end

      private

      def module_path
        "/api/v2/internal/#{customer_id}"
      end

      def parse_for_error(response)
        if response.body.is_a? Hash
          [response.body['replyText'], response.status, response.body['replyCode']]
        else
          super
        end
      end
    end
  end
end
